#include "mbed.h"

SPI spi(p5, p6, p7); // mosi1, miso1, sclk1
DigitalOut cs(p8);   // ssel1

/* tx, rx    default Baudrate:9600bps
   p26=txd1=P2_0,  p25=rxd1=P2_1 */
Serial pc(P2_0, P2_1);
//Serial pc(USBTX, USBRX); // tx, rx

int main() {
  // Setup the spi for 8 bit data, high steady state clock,
  // second edge capture, with a 1MHz clock rate
  spi.format(8,3);
  spi.frequency(1000000);
  while(1){
    // Select the device by seting chip select low
    cs = 0;

    // Send 0x8f, the command to read the WHOAMI register
    spi.write(0x8F);

    // Send a dummy byte to receive the contents of the WHOAMI register
    int whoami ; //spi.write(0x00);
     pc.printf("WHOAMI register = 0x%X\n", whoami++);

    // Deselect the device
    cs = 1;
  }
}
